import java.sql.*;
import java.io.*;
import java.util.regex.*;
import java.util.*;

class CreateDB {
public static void main(String args[]) {
	try{
		BufferedReader in = new BufferedReader(new FileReader("pwd.txt"));
		String line = in.readLine();
		StringTokenizer stt = new StringTokenizer(line,",");
		String hostname = stt.nextToken();
		String uname = stt.nextToken();
		//System.out.println(uname);
		String pwd = "";
		if(stt.hasMoreTokens()) {
			pwd = stt.nextToken();
		}
		//System.out.println(pwd);
		String url = "";
		//if(pwd==null)
			//url = "jdbc:mysql:///mysql?user="+uname+"&password=";
		//else
		url = "jdbc:mysql://"+hostname+"/mysql?user="+uname+"&password="+pwd;
		Class.forName("com.mysql.jdbc.Driver").newInstance();
		//System.out.println(url);
        Connection conn=DriverManager.getConnection(url);
        Statement s = conn.createStatement();
   		s.executeUpdate("create database if not exists logic_fence;");
   		s.executeUpdate("use logic_fence;");
   		String tabl1 = "state_tabl";
   		String tabl2 = "property_tabl";
   		String tabl3 = "appl_ids";
   		String tabl4 = "queue_appl";
   		
		String sqlString = "DROP TABLE IF EXISTS "+ tabl1;
		s.executeUpdate(sqlString);

   		sqlString = "CREATE TABLE IF NOT EXISTS "+ tabl1 + "(statename VARCHAR(20) primary key, islocked int(11), no_of_applications int(11)) ENGINE=InnoDB" ;
		s.executeUpdate(sqlString);
		
		// insert the states in the table state_tabl from StateDefs.xml and StartStates.txt;
		in = new BufferedReader(new FileReader("StateDefs.xml"));
		String REGEX = "<name>";
		Pattern pattern = Pattern.compile(REGEX);
		Matcher matcher;

		String states = "", str="";
		
    	while ((str = in.readLine())!=null) {
	   		matcher = pattern.matcher(str.trim());
			StringTokenizer st = new StringTokenizer(str.trim(),"><");
    		if(matcher.find()) {
    			st.nextToken();
    			if(!states.equals(""))
    				states = states + "," + st.nextToken();
    			else
    				states = states + st.nextToken();
    		}
    	}
    	in.close();
    	
    	in = new BufferedReader(new FileReader("outputStateDefs.xml"));
		REGEX = "<current>";
		String REGEX2 = "<future>";
		pattern = Pattern.compile(REGEX);
		Pattern pattern2 = Pattern.compile(REGEX2);
		Matcher matcher2;

		//states = ""; 
		str="";
		
    	while ((str = in.readLine())!=null) {
	   		matcher = pattern.matcher(str.trim());
			matcher2 = pattern2.matcher(str.trim());
			StringTokenizer st = new StringTokenizer(str.trim(),"><");
    		if(matcher.find() || matcher2.find()) {
    			st.nextToken();
    			if(!states.equals(""))
    				states = states + "," + st.nextToken();
    			else
    				states = states + st.nextToken();
    		}
    	}
    	in.close();
    	
    	in = new BufferedReader(new FileReader("inputStateDefs.xml"));

		//states = ""; 
		str="";
		
    	while ((str = in.readLine())!=null) {
	   		matcher = pattern.matcher(str.trim());
			matcher2 = pattern2.matcher(str.trim());
			StringTokenizer st = new StringTokenizer(str.trim(),"><");
    		if(matcher.find() || matcher2.find()) {
    			st.nextToken();
    			if(!states.equals(""))
    				states = states + "," + st.nextToken();
    			else
    				states = states + st.nextToken();
    		}
    	}
    	in.close();
    	
    	in = new BufferedReader(new FileReader("StartStates.txt"));
    	states = states + "," + in.readLine();
    	in.close();
    	System.out.println(states);
    	
   		String allStates[] = states.split(",");
   		
   		// remove duplicates
   		LinkedHashSet linkedhs = new LinkedHashSet();
   		for(int i=0; i < allStates.length; i++) {
   			linkedhs.add(allStates[i]);
   		}
   		
   		Iterator iter = linkedhs.iterator();
   		
   		while(iter.hasNext()) {
   			String state = (String) iter.next();
   			String insertStmt = "insert into " + tabl1 + " values (\""+state+"\",0,0)";
   			s.executeUpdate(insertStmt);
   		}

		sqlString = "DROP TABLE IF EXISTS "+ tabl3;
		s.executeUpdate(sqlString);

    	sqlString = "CREATE TABLE IF NOT EXISTS "+ tabl3 + "(appl_id int primary key) ENGINE=InnoDB";  // used applications
		s.executeUpdate(sqlString);
		
		sqlString = "DROP TABLE IF EXISTS "+ tabl4;
		s.executeUpdate(sqlString);

		sqlString = "CREATE TABLE IF NOT EXISTS "+ tabl4 + "(appl_id int) ENGINE=InnoDB";  // queue of applications waiting for state transition
		s.executeUpdate(sqlString);
		
		sqlString = "DROP TABLE IF EXISTS "+ tabl2;
		s.executeUpdate(sqlString);

		sqlString = "CREATE TABLE IF NOT EXISTS "+ tabl2 + "(appl_id int primary key, statename varchar(20)) ENGINE=InnoDB";
		s.executeUpdate(sqlString);

		sqlString = "CREATE INDEX stat on "+ tabl2 + "(statename)";
		s.executeUpdate(sqlString);

   		System.out.println("Tables created");
   		s.close();
   		//conn.close();
   		
   		
   		s = conn.createStatement();
   		
   		// Create property_tabl
		in = new BufferedReader(new FileReader("properties.xml"));
		REGEX2 = "<state_properties>.+</state_properties>";
		pattern2 = Pattern.compile(REGEX2);
		sqlString = "ALTER TABLE "+ tabl2 + " ADD COLUMN (";

    	while ((str = in.readLine())!=null) {
	   		matcher = pattern2.matcher(str.trim());
			//StringTokenizer st = new StringTokenizer(str.trim(),"><");
    		if(matcher.find()) {
    			//System.out.println("Entered");
    			StringTokenizer st = new StringTokenizer(str.trim(),"<>");
    			st.nextToken();
    			String properties = st.nextToken();
    			String[] allPropts = properties.split(";");
		   		for(int i=0; i < allPropts.length; i++) {
    				st = new StringTokenizer(allPropts[i].trim()," ");
    				String type = st.nextToken();
    				String property = st.nextToken();
    				sqlString = sqlString + property + " ";
    				
    				if(type.equals("short"))
    					type = "smallint";
    				else if(type.equals("byte"))
    					type = "smallint";
    				else if(type.equals("long"))
    					type = "int(15)";
    				else if(type.equals("String"))
    					type = "varchar(50)";
    				else if(type.equals("Date"))
    					type = "date";
    				else if(type.equals("float"))
    					type = "double";
    				// int, float, double, boolean, char has same data type in MySQL
    				// But float requires a double type in DB due to lack of accuracy	
    				sqlString = sqlString + type;
    				if(i==allPropts.length-1)
    					sqlString = sqlString + ")";
    				else
    					sqlString = sqlString + ", ";
    			}
				s.executeUpdate(sqlString);
				
		   		for(int i=0; i < allPropts.length; i++) {
    				st = new StringTokenizer(allPropts[i].trim()," ");
    				String type = st.nextToken();
    				String property = st.nextToken();
    				sqlString = "create index ind" + (i+1) + " on " + tabl2 + "(" + property + ")";
    				s.executeUpdate(sqlString);
    			}
				
    			break;
    		}
    	}
    	in.close();
    	s.close();
    	s = conn.createStatement();
	}
	catch (FileNotFoundException fne)
	{
		System.out.println("configuration.xml not found. No predicate added.");
	}
	catch(Exception e)
	{
	System.out.println("Database or IO error: "+e);
	}
	
}
}
