open (INFILE,"stateDefs.xml");
@dp=<INFILE>;
close INFILE;
$precision = 0;
foreach $line(@dp)
{
    if($line =~ /<double precision>(.+)<\/double precision>/)
    {
	$precision = $1;
	$precision =~ s/\s//g;
	last;
    }
}

open (INFILE,"configuration.xml");
@vars=<INFILE>;
close INFILE;
@allProps = ();
foreach $line(@vars)
{
    if($line =~ /<state_properties>(.+)<\/state_properties>/)
    {
	$props = $1;
	@allProps = split(/;/,$props);
        last;
    }
}

@dvarlist = ();  # required for comparison of double variables
foreach $item(@allProps)
{
    #print $item . " \n";    
    if($item =~ /^\s*double\s+(.+)/)
    {
	$dvar = $1;
	$dvar =~ s/\s//g;
	push(@dvarlist, $dvar);
	#print $dvar . " \n";
    }
}



open (INFILE,"configuration.xml");
open (OUTFILE,">config.java");
@config=<INFILE>;
$temp = join("",@config);
$temp =~ s/\s->\s/->/g;
$temp =~ s/\n//g;
$temp =~ s/<state_properties>(.+)<\/state_properties>//g;  #different from <state_used> tag
$temp =~ s/<db_host_ip>(.+)<\/db_host_ip>//g;
$temp =~ s/<config>//g;
#$temp =~ s/<\/config>//g;
#print $temp;
@configs= split("<\/config>",$temp);
foreach $conf(@configs)
{
 if ($result=$conf=~ /(.+)->(.+)->(.+)/)
    {
	#print $conf."\n";
        #print  $1." ".$2." ".$3."\n";
	if ($2 ne "O")
	{    
	$stt = $3;
	$stt =~ s/\s//g;
	$temp=$enter{$stt};
	$enter{$stt}=$temp."--".$conf; 
	}
        if ($2 eq "O")
	{
	#$1 =~ s/<state_used>(.+)<\/state_used>//g;
	$st = $1;
	$st =~ s/<state_used>(.+)<\/state_used>//g;
	$st =~ s/\s//g;
	$temp=$leave{$st};
	$leave{$st}=$temp."--".$conf;
	}
    }

}

print OUTFILE "static boolean config_enter(String stateName){\n";
print OUTFILE "try {\n";
while (($state, $constraint) = each(%enter)) {  # $constraint have all P and F constarints for a single $state
	#print $constraint." ".$state."\n";
	print  OUTFILE "\nif (stateName.compareTo(\"$state\")==0){\n";
	@cons_on_state=split(/--/,$constraint);
	my %stts = ();
	foreach $cond(@cons_on_state)  # each constraint of P or F type for a single state
	{
	$cond =~ /<state_used>(.+)<\/state_used>/;
	$state_used=$1;
	$state_used =~ s/\n//g;
	$state_used =~ s/\s//g;
	@states_used={};
	@states_used=split(/\,/,$state_used);
	foreach $stu(@states_used)  # remove duplicates
	   {
	    $stu =~ s/\s+//g;
	    $stu =~ s/\n+//g;
	    $stts{$stu} = "anything";
	   }
	$cond =~ s/<state_used>(.+)<\/state_used>//g;
	}
	@states_used = keys(%stts);
	foreach $stu(@states_used)
	   {
	    #print $stu."\n";
	    print OUTFILE "initialize_array\_$stu();\n";
	   }
	#print "\n";
	
	print OUTFILE "if (";

	$count=0;
	foreach $con(@cons_on_state)
	{ 
	    	#print $con;
		
		($f,$s,$t)=split(/->/,$con);
		#print $f." ".$s." ".$t;
		#$con=~ /(.+)->(.+)->(.+)/;
		#$f =~ s/\s//g;
		$f =~ s/\r//g;
		
		foreach $dvar(@dvarlist)
		{
		    #print $dvar;
		    while($f =~ /["\s]$dvar\s*(=|<>)\s*(-*\d+\.\d*)/)
		    {
			#print "match ". $1;
			$low = $2 - $precision;
			$hi = $2 + $precision;
			#print $1;
			if($1 eq "=")
			{
			    $f =~ s/(["\s])$dvar\s*=\s*(-*\d+\.\d*)/$1$dvar BETWEEN $low and $hi/;
			}
			elsif($1 eq "<>")
			{
			    $f =~ s/(["\s])$dvar\s*<>\s*(-*\d+\.\d*)/$1$dvar NOT BETWEEN $low and $hi/;
			}
		    }
		}
		
		if ($s eq "P")
		{
		#@states=split(/\|\|/,$1);
		#foreach $st(@states)
		#{
		    $count=$count+1;
		    #print "count=$count";
		    if($count==1){
			print OUTFILE $f}
		    if( $count>1)
			{
			print OUTFILE "&& ".$f;
			}	
		#}
		}
		if ($s eq "F")
		{
		#@states=split(/\|\|/,$1);
		#foreach $st(@states)
		#{
		    $count=$count+1;
		    #print "count=$count";
		    if($count==1){
		        print OUTFILE "!".$f;
		    }
		    if( $count>1)
		    {
		    print OUTFILE "&& !".$f;
		    }
		#}
		}
		}
	print  OUTFILE ")
	        	return (true);
		    else return (false);
		}";    
}
print OUTFILE "\nreturn(true);\n";
print OUTFILE "	} catch(Exception e) {
		return false;
	}
}\n";


print OUTFILE "\n\nstatic boolean config_exit(String stateName){\n";
print OUTFILE "try {\n";
while (($state, $constraint) = each(%leave)) {
	#print $constraint." ".$state."\n";
	print  OUTFILE "\nif (stateName.compareTo(\"$state\")==0){\n";
	@cons_on_state=split(/--/,$constraint);
	my %stto = ();
	foreach $cond(@cons_on_state)
	{
	$cond =~ /<state_used>(.+)<\/state_used>/;
	$state_used=$1;
	$state_used =~ s/\n//g;
	$state_used =~ s/\s//g;
	@states_used={};
	@states_used=split(/\,/,$state_used);
	foreach $stu(@states_used)  # remove duplicates
	   {
	    $stu =~ s/\s+//g;
	    $stu =~ s/\n+//g;
	    $stto{$stu} = "anything";
	   }
	$cond =~ s/<state_used>(.+)<\/state_used>//g;
	}
	@states_used = keys(%stto);
	foreach $stu(@states_used)
	   {
	    print OUTFILE "initialize_array\_$stu();\n";
	    }
	$cond =~ s/<state_used>(.+)<\/state_used>//g;
	#print "\n";
	
	print OUTFILE "if (";

	$count=0;
	foreach $con(@cons_on_state)
	{ 
	    	#print $con;
		
		($f,$s,$t)=split(/->/,$con);
		#print $f." ".$s." ".$t;
		#$con=~ /(.+)->(.+)->(.+)/;

		foreach $dvar(@dvarlist)
		{
		    #print $dvar;
		    while($t =~ /["\s]$dvar\s*(=|<>)\s*(-*\d+\.\d*)/)
		    {
			#print "match ".$1;
			$low = $2 - $precision;
			$hi = $2 + $precision;
			#print $1;
			if($1 eq "=")
			{
			    $t =~ s/(["\s])$dvar\s*=\s*(-*\d+\.\d*)/$1$dvar BETWEEN $low and $hi/;
			}
			elsif($1 eq "<>")
			{
			    $t =~ s/(["\s])$dvar\s*<>\s*(-*\d+\.\d*)/$1$dvar NOT BETWEEN $low and $hi/;
			}
		    }
		}

		if ($s eq "O")
		{
		#@states=split(/\|\|/,$1);
		#foreach $st(@states)
		#{
		    $count=$count+1;
		    #print "count=$count";
		    if($count==1){
			print OUTFILE $t
		    }
		    if( $count>1)
			{
			print OUTFILE $t;
			}	
		#}
		}
		}
	print  OUTFILE ")
	        	return (true);
		    else return(false);
		}";    
}
print OUTFILE "\nreturn(true);\n";
print OUTFILE "	} catch(Exception e) {
		return false;
	}
}\n";