open (OUTFILE,">ChkStSpace.java");
print OUTFILE "import java.sql.*;\n";
print OUTFILE "\nimport java.util.*;\n";
print OUTFILE "\nimport java.util.regex.*;\n";
print OUTFILE "\nimport java.io.*;\n";

open (INFILE,"declarations.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

print OUTFILE "\npublic class ChkStSpace{\n";
print OUTFILE "//****************declarations**********************\n";
open (INFILE,"stateVars.txt");
@vars=<INFILE>;
foreach $decl(@vars)
{
$decl =~ s/\n//g;
print OUTFILE "static "."$decl;\n";
print OUTFILE "static "."$decl"."_old;\n";
}
close INFILE;
open (INFILE,"configuration.xml");
@temp=<INFILE>;
$temp1=join("",@temp);
$temp1 =~ /<state_properties>(.+)<\/state_properties>/;
$configs=$1;
$configs =~ s/<state_properties>//g;
$configs =~ s/<\/state_properties>//g;
$configs =~ s/\n//g;
@state_props=split(/\;/,$configs);
foreach $state_prop(@state_props)
{
    print OUTFILE "static ".$state_prop.";\n";
}



print OUTFILE "static String lastState;\n";
print OUTFILE "static Connection conn;\n";
print OUTFILE "static int callnumber;\n";
print OUTFILE "static BufferedWriter bw;\n";
print OUTFILE "static int applId;\n";


print OUTFILE "static Thread shutdownActions=new Thread(){
	public void run()
	{
	 try{
		Statement s=conn.createStatement();
		s.executeQuery(\"start transaction\");		
		if(lastState!=null)
		{
		int rs=s.executeUpdate(\"update state_tabl set no_of_applications=no_of_applications-1 where statename=\\\"\"+lastState+\"\\\"\");
		}

		if(applId!=0)
		{
			int rs2=s.executeUpdate(\"delete from  property_tabl where appl_id=\"+applId);
			//s.executeQuery(\"LOCK TABLE appl_ids WRITE\");  // required if Ctrl+C is pressed when other two tables already locked
			s.executeUpdate(\"delete from  appl_ids where appl_id=\"+applId);
			//s.executeQuery(\"UNLOCK TABLES\");
			s.executeQuery(\"commit\");
			if(bw!=null)
			    bw.close();
		}
		}
	catch (Exception e)
	{
		System.out.println(\"DB error in shutdownActions: \" + e);
		try {
		    Statement s=conn.createStatement();
		    s.executeQuery(\"rollback\");
		} catch(SQLException sqle) {}
		run();
	}
	}
};\n";

open (INFILE,"stateDefs.xml");
@lines=<INFILE>;
foreach $line(@lines)
{
if($result= $line =~ /<name>(.+)<\/name>/)
{
print OUTFILE "\nstatic appl[] appl_".$1.";\n";
}
}
close INFILE;

print OUTFILE "//****************methods***************************\n";
print OUTFILE "\npublic static int checkTransitionValidity(String value,String varName,int applicationId){\n";
print OUTFILE "if(callnumber==0)
		{
		callnumber=1;
		applId=applicationId;
		}";

print OUTFILE "try{
		Statement s=conn.createStatement();

		// Implement the queue for fairness
		/*ResultSet res_q = s.executeQuery(\"select appl_id from queue_appl where appl_id=\"+applId);
		if(!res_q.next()) {
			s.executeUpdate(\"insert into queue_appl values(\"+applId+\")\");
		}
		
		res_q = s.executeQuery(\"select appl_id from queue_appl\");
		res_q.next();
		int appId = res_q.getInt(1);
		try {
		    bw.write(\"\\r\\nFairness violated: Transition not allowed\\r\\n\");
		catch (IOException ioe) {}
		if(appId!=applId) {
			return 0;
		}*/
		
		//ResultSet res=s.executeQuery(\"LOCK TABLE state_tabl WRITE , property_tabl WRITE\");
		ResultSet res=s.executeQuery(\"start transaction\");
		}
		catch(Exception e)
		{
		System.out.println(\"System Error\");
		}\n";    
print OUTFILE "String currentState=determineCurrState();\n";
print OUTFILE "	    String futureState=determineFutureState(varName,value);
		if(currentState.equals(futureState)) {
		try{
		Statement s=conn.createStatement();
		//ResultSet res=s.executeQuery(\"UNLOCK TABLES\");
		ResultSet res=s.executeQuery(\"rollback\");
		//s.executeUpdate(\"delete from  queue_appl where appl_id=\"+applId);
		}
		catch(Exception e)
		{
		System.out.println(\"System Error\");
		}
    	changeValue(varName,value);    
		return (1);
	}	\n		";

print OUTFILE "if (want_to_leave(currentState)) {\n";
print OUTFILE "	    //String futureState=determineFutureState(varName,value);\n";
print OUTFILE "	    if (want_to_enter(futureState)) {\n";
print OUTFILE "	    try {\n";
print OUTFILE "	    if(updateStateInDB(currentState,futureState,applicationId)) {\n";
print OUTFILE "	    changeValue(varName,value);\n";
print OUTFILE "		Statement s=conn.createStatement();
		//ResultSet res=s.executeQuery(\"UNLOCK TABLES\");
		ResultSet res=s.executeQuery(\"commit\");
		//s.executeUpdate(\"delete from  queue_appl where appl_id=\"+applId);\n";

print OUTFILE "	    return (1);\n		}";
print OUTFILE "		else {
		Statement s=conn.createStatement();
		//ResultSet res=s.executeQuery(\"UNLOCK TABLES\");
		ResultSet res=s.executeQuery(\"rollback\");
		//s.executeUpdate(\"delete from  queue_appl where appl_id=\"+applId);
		return (0);
		}
	}
		catch(Exception e)
		{
		System.out.println(\"System Error\");
		}
	    //return (1);";

print OUTFILE "\n   }\n";
print OUTFILE "	    else {
		try{
		Statement s=conn.createStatement();
		//ResultSet res=s.executeQuery(\"UNLOCK TABLES\");
		ResultSet res=s.executeQuery(\"rollback\");
		bw.write(\"\\r\\nEntry to \"+ futureState +\": Transition not allowed\\r\\n\");
		}
		catch(Exception e)
		{
		System.out.println(\"System Error\");
		}\n    
		return(0);\n}\n";
print OUTFILE "\n   }\n";
print OUTFILE "	    else {
		try{
		Statement s=conn.createStatement();
		//ResultSet res=s.executeQuery(\"UNLOCK TABLES\");
		ResultSet res=s.executeQuery(\"rollback\");
		bw.write(\"\\r\\nExit from \"+ currentState +\": Transition not allowed\\r\\n\");
		}
		catch(Exception e)
		{
		System.out.println(\"System Error\");
		}\n    
		return(0);\n}\n";
print OUTFILE "	    return(0);\n}\n";


open (INFILE,"determineCurrentState.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

open (INFILE,"determineCurrState.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

open (INFILE,"wanttoexit.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

open (INFILE,"wanttoenter.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

open (INFILE,"determineFutureState.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

open (INFILE,"determineFutOutState.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

open (INFILE,"determineFutInState.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

open (INFILE,"config.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

open (INFILE,"changeVarname.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

open (INFILE,"FilledandCount.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

open (INFILE,"numberOfandgetval.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

open (INFILE,"connectDb.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

open (INFILE,"initialize_array.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

open (INFILE,"updateStateProperties.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

open (INFILE,"updateStatePropertiesInDb.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

open (INFILE,"updateStateInDb.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

open (INFILE,"checkTransitionOnOutput.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

open (INFILE,"checkTransitionOnInput.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

open (INFILE,"checkTransitionOnDBOutput.java");
@lines=<INFILE>;
$file=join("",@lines);
print OUTFILE $file;
close INFILE;
print OUTFILE "\n\n";

print OUTFILE "\n}\n";